import type { WritableAtom, SetStateAction } from 'jotai';
declare type CommonState<Value> = {
    value: Value;
    isDirty: boolean;
};
declare type AsyncState<Value> = CommonState<Value> & ({
    isValidating: true;
} | {
    isValidating: false;
    isValid: true;
} | {
    isValidating: false;
    isValid: false;
    error: unknown;
});
declare type SyncState<Value> = CommonState<Value> & ({
    isValid: true;
} | {
    isValid: false;
    error: unknown;
});
declare type CommonOptions<Value> = {
    areEqual?: (a: Value, b: Value) => boolean;
};
declare type AsyncOptions<Value> = CommonOptions<Value> & {
    validate: (value: Value) => Promise<Value>;
};
declare type SyncOptions<Value> = CommonOptions<Value> & {
    validate: (value: Value) => Value;
};
export declare function atomWithValidate<Value>(initialValue: Value, options: AsyncOptions<Value>): WritableAtom<AsyncState<Value>, SetStateAction<Value>>;
export declare function atomWithValidate<Value>(initialValue: Value, options: SyncOptions<Value>): WritableAtom<SyncState<Value>, SetStateAction<Value>>;
export {};
